# TPK4186 - Advanced Tools for Performance Engineering
# ThueMorseSequence.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

def CalculateNextInThueMorseSequence(string):
  result = string
  i = 0
  while i<len(string):
    if string[i]=='0':
      result += '1'
    else:
      result += '0'
    i += 1
  return result

def CalculateIterationInThueMorseSequence(string, numberOfIterations):
  result = string
  i = 0
  while i<numberOfIterations:
    result = CalculateNextInThueMorseSequence(result)
    i += 1
  return result
    
print(CalculateIterationInThueMorseSequence("0", 10))

