# TPK4186 - Advanced Tools for Performance Engineering
# TowerOfHanoi.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Tower of Hanoi
def MoveStack(n, sourceRod, targetRod, spareRod):
  if n==1:
    MoveDisk(1, sourceRod, targetRod)
  else:
    MoveStack(n-1, sourceRod, spareRod, targetRod)
    MoveDisk(n, sourceRod, targetRod)
    MoveStack(n-1, spareRod, targetRod, sourceRod)

def MoveDisk(n, sourceRod, targetRod):
  print("move disk " + str(n) + " from rod " + sourceRod + " to rod " + targetRod)

# Application
MoveStack(6, "A", "B", "C")