# TPK4186 - Advanced Tools for Performance Engineering
# LogisticMap.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

def LogisticMap(r, x0, n, k):
  x = x0
  for i in range(1, n+1):
    x = r * x * (1-x)
    if i>n-k:
      print(str(i) + "\t" + str(x))

LogisticMap(2.8, 0.7, 100000, 10)
