# TPK4186 - Advanced Tools for Performance Engineering
# SyracuseConjecture.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

n = 10816191671 # Well, you can put any positive integer here
numberOfSteps = 0
while n!=1:
  numberOfSteps += 1
  print("Step: " + str(numberOfSteps) + ", n = " + str(n))
  if n%2==0:
    n = n//2
  else:
    n = 3*n + 1
print("Yes! n = " + str(n) + ". I made it in " + str(numberOfSteps) + " steps.")
